递推(dp)-HDU5366

来源:互联网 发布:北京蓝鲸网络官网 编辑:程序博客网 时间:2024/05/19 00:16

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5366

Problem Description

ZJiaQ want to become a strong man, so he decided to play the mook jong。ZJiaQ want to put some mook jongs in his backyard. His backyard consist of n bricks that is 1*1,so it is 1*n。ZJiaQ want to put a mook jong in a brick. because of the hands of the mook jong, the distance of two mook jongs should be equal or more than 2 bricks. Now ZJiaQ want to know how many ways can ZJiaQ put mook jongs legally(at least one mook jong).
Input
There ar multiply cases. For each case, there is a single integer n( 1 < = n < = 60)
Output
Print the ways in a single line for each case.
Sample Input
1
2
3
4
5
6
Sample Output
1
2
3
5
8
12

题解:

状态转移方程: dp[i]=dp[i-1]+dp[i-3]+1。
dp[i]的含义是到i这个位置为止,有多少种方案数,也就是答案。因为dp表示的是合法的解,所以之前一定已经至少放了一个木桩了。dp[i-1]代表的是当前位置i不放木桩,dp[i-3]代表的是当前位置放,因为间隔为2,所以不论前面第三个位置有没有,当前位置i都可以放置1个木桩,至于最后加上的一个1,它代表的是前面i-1个位置都没放置木桩,而在当前位置i放置一个木桩,这也是一组合法的解,故加上1。

#include<bits/stdc++.h>#define ll long longusing namespace std;ll a[100];int main(){    a[1]=1;a[2]=2;a[3]=3;    for(int i=4;i<=60;i++)    {        a[i]=a[i-3]+a[i-1]+1;    }    int n;    while(~scanf("%d",&n))    {        printf("%I64d\n",a[n]);    }}
原创粉丝点击